;
;  This file is copyright (c) 1987 by DDI.  All rights reserved.
;
RETF    macro
        db      0cbh                    ;force MASM to assemble a RET FAR
                                        ;without a PROC FAR
        endm
fun     segment
assume  cs:fun,ds:fun,es:fun,ss:fun
;
;  Program to load a VIM image file to real memory.
;
;   Assumptions:
;     640K machine, DOS fits in 65280 bytes, will restore CGA screen
;
        org     100h                    ;this is a .COM file
loader: mov     si,offset startmoved    ;DS:SI = next routine
        mov     ax,8800h                ;new program segment
        mov     es,ax                   ;ES = new segment
        mov     di,si                   ;ES:DI = new location for next routine
        mov     cx,offset progend       ;end of program to move + 1
        sub     cx,si                   ;difference is # of bytes to move
        cli                             ;do not disturb
        cld                             ;up
        rep     movsb                   ;move it!
        push    ax                      ;push new segment
        mov     bx,offset startmoved    ;get new offset
        push    bx                      ;push it
        RETF                            ;Do a far return to the moved code
errorabort:
        int     20h                     ;error, return to DOS
                                        ;note that INT 20 needs CS pointing to
                                        ;the PSP
startmoved:
        mov     ss,ax                   ;set SS
        mov     sp,offset startmoved    ;and SP to below program
        push    ds                      ;save old CS(=DS) for error abort
        mov     ds,ax                   ;set DS
        sti                             ;allow interrupts again
        mov     ax,03d00h               ;set up for DOS call
        mov     dx,offset imagename     ;filename of image file
        int     21h                     ;call DOS
        jae     loadit                  ;no carry = no error, go load it
        mov     ax,offset errorabort    ;time to quit
        push    ax                      ;quit offset to stack
        RETF                            ;far return back to the exit
;
;   It's now too late for error aborts
;
loadit: mov     word ptr [filehandle],ax  ;save the file handle
        mov     bx,ax                   ;handle to BX for read
        mov     cx,34                   ;read 34 bytes, the MDA parameters
        mov     dx,offset thedump       ;into the dump area
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
;
;   The next read will be the CGA parameters, which will be kept
;
        mov     bx,word ptr [filehandle]  ;handle to BX for read
        mov     cx,32                   ;read 32 bytes, the CGA parameters
        mov     dx,offset videostuff    ;into the video info buffer
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
;
;   Next, read past the EGA parameters
;
        mov     bx,word ptr [filehandle]  ;file handle to BX
        mov     cx,8+10+6+34+2          ;read past the next 5 records
        mov     dx,offset thedump       ;into the disposal area
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
;
;   Read the registers
;
        mov     bx,word ptr [filehandle]  ;file handle to BX
        mov     cx,28                   ;read 28 bytes, the registers
        mov     dx,offset regs          ;into the register buffer
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
;
;   Restore the video memory
;
        mov     bx,word ptr [filehandle]  ;file handle to BX
        mov     cx,4096                 ;size of video buffer
        mov     ax,0b800h               ;video segment
        mov     ds,ax                   ;move to DS
        mov     dx,0                    ;load location is DS:0
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
        push    cs                      ;move CS
        pop     ds                      ;back to DS
;
;   Now read in the DOS information from the virtual memory
;
        mov     bx,word ptr [filehandle]  ;get the handle
        mov     cx,0ff00h               ;a big number
        mov     dx,9000h                ;use 9000h
        mov     ds,dx                   ;as the segment
        mov     dx,0                    ;9000:0 is the transfer address
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
;
;   Now, to read the rest of memory
;
readloop:
        mov     bx,word ptr cs:[filehandle]  ;get the handle
        mov     cx,0ff00h               ;big number
        lds     dx,dword ptr cs:[loadofs]    ;get the load address
        mov     ah,3fh                  ;fn = read
        int     21h                     ;call DOS
        mov     dx,ax                   ;save bytes read
        shr     ax,1                    ;/2
        shr     ax,1                    ;/4
        shr     ax,1                    ;/8
        shr     ax,1                    ;/16
        add     word ptr cs:[loadseg],ax     ;add to segment
        mov     ax,dx                   ;get bytes read again
        and     ax,000fh                ;mod 16
        add     word ptr cs:[loadofs],ax     ;add to offset
        cmp     dx,0                    ;were 0 bytes read?
        jne     readloop                ;no, keep going
        mov     ax,cs                   ;get CS
        mov     ds,ax                   ;into DS
;
;   now start the final setup
;
        mov     dx,3d4h                ;6845 index register
        mov     cx,18                  ;need 18 bytes
        mov     bx,offset videostuff   ;base of video data
videoloop1:
        mov     ax,18
        sub     ax,cx                  ;18-cx = index to 6845 regs
        mov     si,ax                  ;si = index into video data
        out     dx,al                  ;select 6845 register
        inc     dx                     ;point to 6845 data register
        mov     al,byte ptr [bx+si]    ;get the data for this port
        out     dx,al                  ;out data to video register
        dec     dx                     ;back to 6845 index register
        loop    videoloop1             ;do next register
        add     bx,26                  ;add offset to port data
        mov     cx,2                   ;only 2 ports are needed
        mov     dx,3d8h                ;starting CGA register
videoloop2:
        mov     si,4
        sub     si,cx                  ;4-cx = index to port values
        mov     al,byte ptr [bx+si]    ;get port data
        out     dx,al                  ;and out it
        inc     dx                     ;address of next port
        loop    videoloop2             ;do next port
;
;   Now move DOS
;
        xor     ax,ax                  ;AX = 0
        mov     es,ax                  ;ES = 0
        mov     di,ax                  ;DI = 0
        mov     si,ax                  ;SI = 0
        mov     dx,9000h               ;DX = 9000h, DOS buffer segment
        mov     ds,dx                  ;DS:SI = loaded DOS, ES:DI = real DOS
        mov     cx,0ff00h              ;big number again
        cli                            ;DO NOT DISTURB!
        cld                            ;UP!
        rep     movsb                  ;new DOS
        mov     ax,cs                  ;mov CS
        mov     ds,ax                  ;to DS
        mov     bx,offset regs         ;pointer to register information
        mov     ax,word ptr [bx]       ;set AX register
        mov     cx,word ptr [bx+2]     ;set CX register
        mov     dx,word ptr [bx+4]     ;set DX register
        mov     sp,word ptr [bx+8]     ;set SP register
        mov     bp,word ptr [bx+10]    ;set BP register
        mov     si,word ptr [bx+12]    ;set SI register
        mov     di,word ptr [bx+14]    ;set DI register
        mov     es,word ptr [bx+16]    ;set ES register
        mov     ss,word ptr [bx+20]    ;set SS register
        push    word ptr [bx+24]       ;push FLAGS
        push    word ptr [bx+18]       ;push CS
        push    word ptr [bx+26]       ;push IP
        mov     ds,word ptr [bx+22]    ;set DS register
        mov     bx,word ptr cs:[bx+6]  ;set BX register
        iret                           ;and start saved program!
;
;   start of data
;
filehandle:     dw      0
loadofs:        dw      0
loadseg:        dw      0ff0h
imagename:      db      'PROGRAM.IMG',0
videostuff:     db      32 dup (0)
regs:           db      28 dup (0)
thedump:        db      0
;
;   the program end
;
progend:
fun     ends
        end     loader
